"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VerticaQuery = void 0;
const BaseQuery_1 = require("./BaseQuery");
const GRANULARITY_TO_INTERVAL = {
    day: 'DD',
    week: 'W',
    hour: 'HH24',
    minute: 'mm',
    second: 'ss',
    month: 'MM',
    quarter: 'Q',
    year: 'YY'
};
class VerticaQuery extends BaseQuery_1.BaseQuery {
    convertTz(field) {
        return `${field} AT TIME ZONE '${this.timezone}'`;
    }
    // eslint-disable-next-line no-unused-vars
    timeStampParam(timeDimension) {
        return this.timeStampCast('?');
    }
    timeGroupedColumn(granularity, dimension) {
        return `TRUNC(${dimension}, '${GRANULARITY_TO_INTERVAL[granularity]}')`;
    }
}
exports.VerticaQuery = VerticaQuery;
//# sourceMappingURL=VerticaQuery.js.map